<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/Button.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Button.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_button_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef BUTTON_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define BUTTON_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_button.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_button.html">Button</a></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">int</span> _pin;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">int</span> _id;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">bool</span> _state;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">volatile</span> <span class="keywordtype">bool</span> _inputFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">bool</span> _changeFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">bool</span> _pressedFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">bool</span> _holdFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> _previousTimer;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">int</span> _clickInterval = 1000;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">int</span> _holdInterval = 1000;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">int</span> _repeatInterval = 1000;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    void (*_cb)(<a class="code" href="class_button.html">Button</a>*, uint8_t, bool);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">bool</span> _read();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">void</span> _setClickInterval(<span class="keywordtype">int</span> x);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span> _setHoldInterval(<span class="keywordtype">int</span> x);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> _setRepeatInterval(<span class="keywordtype">int</span> x);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="class_button.html#aeff212895aef4677c616d34494220e14">   66</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_button.html#aeff212895aef4677c616d34494220e14">kEventPressed</a> = 0;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="class_button.html#a0c1101a90c59dd34cb05a6cdf94edaff">   71</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_button.html#a0c1101a90c59dd34cb05a6cdf94edaff">kEventReleased</a> = 1;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="class_button.html#a41963b0ccc28009de8a46c52cad5b9b4">   76</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_button.html#a41963b0ccc28009de8a46c52cad5b9b4">kEventClicked</a> = 2;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="class_button.html#a919fb4da7e37b23eaeb08b6194b2338c">   81</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_button.html#a919fb4da7e37b23eaeb08b6194b2338c">kEventHeld</a> = 3;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="class_button.html#a0815fb27da6cee2d24f53f26155d0031">   86</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> uint8_t <a class="code" href="class_button.html#a0815fb27da6cee2d24f53f26155d0031">kEventTick</a> = 4;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="class_button.html#ac61739f093022155c9c7c1d281feffdb">   91</a></span>&#160;    <a class="code" href="class_button.html#ac61739f093022155c9c7c1d281feffdb">Button</a>(<span class="keywordtype">int</span> pin, <span class="keywordtype">int</span> <span class="keywordtype">id</span> = 99);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="class_button.html#a8fc0f6d87068ccd44e07b1d764eddf3f">  100</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_button.html#a8fc0f6d87068ccd44e07b1d764eddf3f">initInterrupts</a>(<span class="keywordtype">void</span> (*<span class="keyword">function</span>)());</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="class_button.html#a94e66e570b29f34aeb0680b7c657265d">  106</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_button.html#a94e66e570b29f34aeb0680b7c657265d">setEventHandler</a>(<span class="keywordtype">void</span> (*<span class="keyword">function</span>)(<a class="code" href="class_button.html">Button</a>*, uint8_t, <span class="keywordtype">bool</span>));</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="class_button.html#a946d9bb84880931ccf3494d84f0ac73a">  111</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_button.html#a946d9bb84880931ccf3494d84f0ac73a">getState</a>();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="class_button.html#a0b024eb643308f2cfa8d13cd93c6b1ca">  116</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_button.html#a0b024eb643308f2cfa8d13cd93c6b1ca">getId</a>();</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="class_button.html#accfe0a939a17dd9426a4c61323c32e7f">  121</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_button.html#accfe0a939a17dd9426a4c61323c32e7f">getClickInterval</a>();</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="class_button.html#a9782adb68590b975c4c7473b1c2716d4">  126</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_button.html#a9782adb68590b975c4c7473b1c2716d4">getHoldInterval</a>();</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="class_button.html#aff7b7fc611d3f412c91aea2082a9b48d">  131</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="class_button.html#aff7b7fc611d3f412c91aea2082a9b48d">getRepeatInterval</a>();</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="class_button.html#a4bd4f650e382a7a5501a12dfb7a6b714">  137</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_button.html#a4bd4f650e382a7a5501a12dfb7a6b714">check</a>();</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="class_button.html#aa5151d4e678a588275cfe773337435af">  144</a></span>&#160;  <span class="keywordtype">void</span>  ICACHE_RAM_ATTR <a class="code" href="class_button.html#aa5151d4e678a588275cfe773337435af">tick</a>();</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;};</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="aclass_button_html"><div class="ttname"><a href="class_button.html">Button</a></div><div class="ttdoc">Event-driven button class.</div><div class="ttdef"><b>Definition:</b> Button.h:18</div></div>
<div class="ttc" id="aclass_button_html_a0815fb27da6cee2d24f53f26155d0031"><div class="ttname"><a href="class_button.html#a0815fb27da6cee2d24f53f26155d0031">Button::kEventTick</a></div><div class="ttdeci">static const uint8_t kEventTick</div><div class="ttdoc">Event ID for button tick (released every _repeatInterval when button held).</div><div class="ttdef"><b>Definition:</b> Button.h:86</div></div>
<div class="ttc" id="aclass_button_html_a0b024eb643308f2cfa8d13cd93c6b1ca"><div class="ttname"><a href="class_button.html#a0b024eb643308f2cfa8d13cd93c6b1ca">Button::getId</a></div><div class="ttdeci">int getId()</div><div class="ttdoc">Returns the button ID.</div></div>
<div class="ttc" id="aclass_button_html_a0c1101a90c59dd34cb05a6cdf94edaff"><div class="ttname"><a href="class_button.html#a0c1101a90c59dd34cb05a6cdf94edaff">Button::kEventReleased</a></div><div class="ttdeci">static const uint8_t kEventReleased</div><div class="ttdoc">Event ID for button release.</div><div class="ttdef"><b>Definition:</b> Button.h:71</div></div>
<div class="ttc" id="aclass_button_html_a41963b0ccc28009de8a46c52cad5b9b4"><div class="ttname"><a href="class_button.html#a41963b0ccc28009de8a46c52cad5b9b4">Button::kEventClicked</a></div><div class="ttdeci">static const uint8_t kEventClicked</div><div class="ttdoc">Event ID for button click (pressed and released within _clickInterval).</div><div class="ttdef"><b>Definition:</b> Button.h:76</div></div>
<div class="ttc" id="aclass_button_html_a4bd4f650e382a7a5501a12dfb7a6b714"><div class="ttname"><a href="class_button.html#a4bd4f650e382a7a5501a12dfb7a6b714">Button::check</a></div><div class="ttdeci">void check()</div><div class="ttdoc">Polls the button's _inputFlag and detects events. This should be called in the sketch's loop() functi...</div></div>
<div class="ttc" id="aclass_button_html_a8fc0f6d87068ccd44e07b1d764eddf3f"><div class="ttname"><a href="class_button.html#a8fc0f6d87068ccd44e07b1d764eddf3f">Button::initInterrupts</a></div><div class="ttdeci">void initInterrupts(void(*function)())</div><div class="ttdoc">Set the function to be called when a pin interrupt occurs. Ideally this wouldn't be needed and the pi...</div></div>
<div class="ttc" id="aclass_button_html_a919fb4da7e37b23eaeb08b6194b2338c"><div class="ttname"><a href="class_button.html#a919fb4da7e37b23eaeb08b6194b2338c">Button::kEventHeld</a></div><div class="ttdeci">static const uint8_t kEventHeld</div><div class="ttdoc">Event ID for button hold (held down for longer than _holdInterval).</div><div class="ttdef"><b>Definition:</b> Button.h:81</div></div>
<div class="ttc" id="aclass_button_html_a946d9bb84880931ccf3494d84f0ac73a"><div class="ttname"><a href="class_button.html#a946d9bb84880931ccf3494d84f0ac73a">Button::getState</a></div><div class="ttdeci">bool getState()</div><div class="ttdoc">Returns the current button state.</div></div>
<div class="ttc" id="aclass_button_html_a94e66e570b29f34aeb0680b7c657265d"><div class="ttname"><a href="class_button.html#a94e66e570b29f34aeb0680b7c657265d">Button::setEventHandler</a></div><div class="ttdeci">void setEventHandler(void(*function)(Button *, uint8_t, bool))</div><div class="ttdoc">Set the function that is called any time a button event is detected. Some example callback functions ...</div></div>
<div class="ttc" id="aclass_button_html_a9782adb68590b975c4c7473b1c2716d4"><div class="ttname"><a href="class_button.html#a9782adb68590b975c4c7473b1c2716d4">Button::getHoldInterval</a></div><div class="ttdeci">int getHoldInterval()</div><div class="ttdoc">Returns button's hold interval.</div></div>
<div class="ttc" id="aclass_button_html_aa5151d4e678a588275cfe773337435af"><div class="ttname"><a href="class_button.html#aa5151d4e678a588275cfe773337435af">Button::tick</a></div><div class="ttdeci">void ICACHE_RAM_ATTR tick()</div><div class="ttdoc">Raises the button's _inputFlag. This should be wrapped in a function in the global scope and fed into...</div></div>
<div class="ttc" id="aclass_button_html_ac61739f093022155c9c7c1d281feffdb"><div class="ttname"><a href="class_button.html#ac61739f093022155c9c7c1d281feffdb">Button::Button</a></div><div class="ttdeci">Button(int pin, int id=99)</div><div class="ttdoc">Class constructor.</div></div>
<div class="ttc" id="aclass_button_html_accfe0a939a17dd9426a4c61323c32e7f"><div class="ttname"><a href="class_button.html#accfe0a939a17dd9426a4c61323c32e7f">Button::getClickInterval</a></div><div class="ttdeci">int getClickInterval()</div><div class="ttdoc">Returns button's click interval.</div></div>
<div class="ttc" id="aclass_button_html_aeff212895aef4677c616d34494220e14"><div class="ttname"><a href="class_button.html#aeff212895aef4677c616d34494220e14">Button::kEventPressed</a></div><div class="ttdeci">static const uint8_t kEventPressed</div><div class="ttdoc">Event ID for button press.</div><div class="ttdef"><b>Definition:</b> Button.h:66</div></div>
<div class="ttc" id="aclass_button_html_aff7b7fc611d3f412c91aea2082a9b48d"><div class="ttname"><a href="class_button.html#aff7b7fc611d3f412c91aea2082a9b48d">Button::getRepeatInterval</a></div><div class="ttdeci">int getRepeatInterval()</div><div class="ttdoc">Returns button's tick interval.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
